/*
Supplementary data structures for GPOS tables
Copyright (C) 2007-2013      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
/* The following is a hybrid between pair_value_record and Class2Record. */
STRUCTURE(hybrid_pair_value_record)
     IF (1 == pair_fmt)
         DATA_UW(secondGlyph)
     ENDIF
     IF (VALUE_FORMAT = VALUE_FORMAT1) ENDIF
     DATA_STR(value1, ValueRecord)
     IF (VALUE_FORMAT = VALUE_FORMAT2) ENDIF
     DATA_STR(value2, ValueRecord)
END_STRUCTURE(hybrid_pair_value_record)
STRUCTURE(hybrid_Class1Record)
     ARRAY_VC(class2Record, class_2_count, hybrid_pair_value_record)
END_STRUCTURE(hybrid_Class1Record)
/* The following is derived from pairpos_table */
STRUCTURE(hybrid_pairpos_table)
     DATA_UW(posFormat)
     IF (pair_fmt = here->posFormat) ENDIF
     DATA_UW(coverage)
     DATA_UW(valueFormat1)
     IF (VALUE_FORMAT1 = here->valueFormat1) ENDIF
     DATA_UW(valueFormat2)
     IF (VALUE_FORMAT2 = here->valueFormat2) ENDIF
     IF (1 == here->posFormat)
         DATA_UW(pairSetCount)
         DATA_VL_UW(pairSetOffset, pairSetCount)
     ELSEIF (2 == here->posFormat)
         DATA_UW(classDef1)
         DATA_UW(classDef2)
         DATA_UW(class1Count)
         DATA_UW(class2Count)
         IF (class_2_count = here->class2Count) ENDIF
         ARRAY_VC(class1Record, here->class1Count, hybrid_Class1Record)
     ENDIF
END_STRUCTURE(hybrid_pairpos_table)
/* The following is derived from pairset_table */
STRUCTURE(hybrid_pairset_table)
     DATA_UW(pairValueCount)
     ARRAY_VC(pairValueRecord, here->pairValueCount, hybrid_pair_value_record)
END_STRUCTURE(hybrid_pairset_table)
