/*
Interfaces for manipulation of sets of integers.
Copyright (C) 2007-2020      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
struct int_range {
  struct int_range *next;
  int start, end;
};
typedef struct int_range *int_set;

int_set create_int_set(void);
void delete_int_set(int_set *x);
int_set *copy_int_set(int_set from, int_set *to);
int_set *add_range(int start, int end, int_set *set);
int_set *add_set(int_set from, int_set *to);
int_set *sub_set(int_set of, int_set *from);
int_set *sub_range(int start, int end, int_set *set);
void print_int_set(FILE *fp, int_set x);
void printf_int_set(FILE *fp, const char *num, const char *none,
		    const char *to, const char *and, int_set x);
