/*
Structured output from data definition
Copyright (C) 2005      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/

#ifdef DATA_UB
  #include "manip_undef.h"
#endif

#define STRUCTURE(type) void MANIP_XGLUE(DISPLAY_, type) (DISPLAY_DEST* fp,\
                                     struct type *here, int*follow,\
                                     const char *name, int level){\
unsigned char      ub_temp; signed char  sb_temp;\
unsigned short int uw_temp; signed short int sw_temp;\
unsigned int       ul_temp; signed int   sl_temp;\
int nover, nskip, i; signed long long int sq_temp;\
*follow = 0; DISPLAY_NAME(name, level); level++;
#ifndef MANIP_XGLUE
  #define MANIP_XGLUE(a,b) MANIP_GLUE(a,b)
  #define MANIP_GLUE(a, b) a ## b
#endif
#define END_STRUCTURE(type) }
#define ALIGN(n)

#define DATA_CH(name) DISPLAY_CH(fp, here->name, #name, level)
#define DATA_UB(name) DISPLAY_UB(fp, here->name, #name, level)
#define DATA_SB(name) DISPLAY_SB(fp, here->name, #name, level)
#define DATA_UW(name) DISPLAY_UW(fp, here->name, #name, level)
#define DATA_SW(name) DISPLAY_SW(fp, here->name, #name, level)
#define DATA_UL(name) DISPLAY_UL(fp, here->name, #name, level)
#define DATA_SL(name) DISPLAY_SL(fp, here->name, #name, level)
#define DATA_SQ(name) DISPLAY_SQ(fp, here->name, #name, level)

#define DATA_N_CH(name,n) DISPLAY_N_CH(fp, here->name, n, #name, level)
#define DATA_N_UB(name,n) DISPLAY_N_UB(fp, here->name, n, #name, level)
#define DATA_N_SB(name,n) DISPLAY_N_SB(fp, here->name, n, #name, level)
#define DATA_N_UW(name,n) DISPLAY_N_UW(fp, here->name, n, #name, level)
#define DATA_N_SW(name,n) DISPLAY_N_SW(fp, here->name, n, #name, level)
#define DATA_N_UL(name,n) DISPLAY_N_UL(fp, here->name, n, #name, level)
#define DATA_N_SL(name,n) DISPLAY_N_SL(fp, here->name, n, #name, level)
#define DATA_N_SQ(name,n) DISPLAY_N_SQ(fp, here->name, n, #name, level)

#define DATA_VL_CH(name,cnt) DISPLAY_N_CH(fp,here->name,here->cnt,#name,level)
#define DATA_VL_UB(name,cnt) DISPLAY_N_UB(fp,here->name,here->cnt,#name,level)
#define DATA_VL_SB(name,cnt) DISPLAY_N_SB(fp,here->name,here->cnt,#name,level)
#define DATA_VL_UW(name,cnt) DISPLAY_N_UW(fp,here->name,here->cnt,#name,level)
#define DATA_VL_SW(name,cnt) DISPLAY_N_SW(fp,here->name,here->cnt,#name,level)
#define DATA_VL_UL(name,cnt) DISPLAY_N_UL(fp,here->name,here->cnt,#name,level)
#define DATA_VL_SL(name,cnt) DISPLAY_N_SL(fp,here->name,here->cnt,#name,level)
#define DATA_VL_SQ(name,cnt) DISPLAY_N_SQ(fp,here->name,here->cnt,#name,level)

#define DATA_VR_CH(nam,n) DISPLAY_N_CH(fp,here->nam,here->_n_##nam,#nam,level)
#define DATA_VR_UB(nam,n) DISPLAY_N_UB(fp,here->nam,here->_n_##nam,#nam,level)
#define DATA_VR_SB(nam,n) DISPLAY_N_SB(fp,here->nam,here->_n_##nam,#nam,level)
#define DATA_VR_UW(nam,n) DISPLAY_N_UW(fp,here->nam,here->_n_##nam,#nam,level)
#define DATA_VR_SW(nam,n) DISPLAY_N_SW(fp,here->nam,here->_n_##nam,#nam,level)
#define DATA_VR_UL(nam,n) DISPLAY_N_UL(fp,here->nam,here->_n_##nam,#nam,level)
#define DATA_VR_SL(nam,n) DISPLAY_N_SL(fp,here->nam,here->_n_##nam,#nam,level)
#define DATA_VR_SQ(nam,n) DISPLAY_N_SQ(fp,here->nam,here->_n_##nam,#nam,level)

#define ALT_UB(name) DISPLAY_UB(fp, (ub_temp = here->name), #name, level)
#define ALT_SB(name) DISPLAY_SB(fp, (sb_temp = here->name), #name, level)
#define ALT_UW(name) DISPLAY_UW(fp, (uw_temp = here->name), #name, level)
#define ALT_SW(name) DISPLAY_SW(fp, (sw_temp = here->name), #name, level)
#define ALT_UL(name) DISPLAY_UL(fp, (ul_temp = here->name), #name, level)
#define ALT_SL(name) DISPLAY_SL(fp, (sl_temp = here->name), #name, level)
#define ALT_SQ(name) DISPLAY_SQ(fp, (sq_temp = here->name), #name, level)

#define ZERO(name)
#define DATA_STR(field, eltype)\
  MANIP_XGLUE(DISPLAY_, eltype)(fp, &here->field, &nover, #field, level);
#define ARRAY_VC(field, n, eltype)\
 DISPLAY_NAME(#field, level);\
 {struct eltype **ptr2; int report; char name[14];\
  if (!here->field) DISPLAY_NONE;\
  for (i=0, ptr2=&here->field; i<(n);i++) {\
    sprintf(name, "[%d]", i);\
    MANIP_XGLUE(DISPLAY_, eltype)(fp, *ptr2, &report, name, level+1);\
    ptr2 = &(*ptr2)->_next;\
  }}
#define ARRAY_TC(field, eltype)\
  DISPLAY_NAME(#field, level);\
  {struct eltype **ptr2; int report = 2, i = 0; char name[14];\
   ptr2 = &here->field;\
   if (!here->field) DISPLAY_NONE;\
   while (2 == report) {\
     sprintf(name, "[%d]", i);\
     MANIP_XGLUE(DISPLAY_, eltype)(fp, *ptr2, &report, name, level+1);\
     ptr2 = &(*ptr2)->_next; i++;\
  }\
  if (report != 1) {\
      fprintf(stderr, "Final/non-final not specified when processing "\
	      "an element of" #field ",/n of type " #eltype ".\n");\
      exit(1);}\
  }
#define IF(condition) if (condition) {
#define ELSE } else {
#define ELSEIF(condition) } else if (condition) {
#define ENDIF }
#define LAST_ONE *follow = 1;
#define NOT_LAST_ONE *follow = 2;
