/*
Transfer of atomic data with sequential memory.
Copyright (C) 2007-2015      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
#ifdef GET_SOURCE
  #undef GET_SOURCE

  #undef GET0
  #undef GET_
  #undef GETB
  #undef GETW
  #undef GETL
  #undef GETQ

  #undef PUT_SOURCE

  #undef PUT0
  #undef PUT_
  #undef PUTB
  #undef PUTW
  #undef PUTL
  #undef PUTQ
#endif
extern int swap_order;
#ifndef flip2
  #define flip2(x) (( (x&0xff)<<8 ) | ( (x)>>8 & 0xff ) )
  #define flip4(x) (( (x&0xff)<<24 ) | ( (x&0xff00)<<8 ) |\
                    ((x)>>8) & 0xff00 | ((x)>>24) & 0xff )
  #define flip8(x) (( (x&0xff)<<56 ) | ( (x&0xff00)<<40 ) |\
                    ( (x&0xff0000)<<24 ) | ( (x&0xff000000)<<8 ) |\
		    ((x)>>8) & 0xff000000 | ((x)>>24) & 0xff0000 |\
		    ((x)>>40) & 0xff00 | ((x)>>56) & 0xff )
#endif
#define GET_ get_meme_
#define GET_SOURCE char*
#define GET0(fp, nskip, pos)\
{ *pos += nskip; *fp += nskip;}
#define GETB(fp, field, pos) field = *(*fp)++; *pos+=1;
#define GETW(fp, field, pos)\
  memcpy(&field, *fp, 2); *fp += 2; if (swap_order) field = flip2(field); *pos+=2;
#define GETL(fp, field, pos)\
  memcpy(&field, *fp, 4); *fp += 4; if (swap_order) field = flip4(field); *pos+=4;
#define GETQ(fp, field, pos)\
  memcpy(&field, *fp, 8); *fp += 8; if (swap_order) field = flip8(field); *pos+=8;

#define PUT_ put_meme_
#define PUT_SOURCE char*
#define PUT0(fp, nskip, pos)\
{ int i; char c=0;\
  *pos += nskip;\
  for (i=nskip; i>0; i--) *(*fp)++ = 0;}
#define PUTB(fp, field, pos) *(*fp)++ = field; *pos+=1;
#define PUTW(fp, field, pos)\
  uw_temp = swap_order ? flip2(field) : field;\
  memcpy(*fp, &uw_temp, 2); *fp += 2; *pos+=2;
#define PUTL(fp, field, pos)\
  ul_temp = swap_order ? flip4(field) : field;\
  mamcpy(*fp, &ul_temp, 4); *fp += 4; *pos+=4;
#define PUTQ(fp, field, pos)\
  sq_temp = swap_order ? flip8(field) : field;\
  memcpy(*fp, &sq_temp, 8); *fp += 8; *pos+=8;
