/*
Freeing of subordinate data structures.
Copyright (C) 2004      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
#include <stdlib.h>
#ifdef DATA_UB
  #include "manip_undef.h"
#endif
#define STRUCTURE(type)\
void free_ ## type(struct type* here) {\
  if (!here) return;
#define END_STRUCTURE(type)\
  free_ ## type(here->_next); free(here->_next); here->_next = 0;}
#define ALIGN(n)

#define DATA_CH(name)
#define DATA_UB(name)
#define DATA_SB(name)
#define DATA_UW(name)
#define DATA_SW(name)
#define DATA_UL(name)
#define DATA_SL(name)
#define DATA_SQ(name)

/* n is a compile-time constant. */
#define DATA_N_CH(name,n)
#define DATA_N_UB(name,n)
#define DATA_N_SB(name,n)
#define DATA_N_UW(name,n)
#define DATA_N_SW(name,n)
#define DATA_N_UL(name,n)
#define DATA_N_SL(name,n)
#define DATA_N_SQ(name,n)

/* count is another field in the same record.
   Note that these structures are not implicitly dynamic. */
#define DATA_VL_CH(name, count)\
  free(here->name); here->name = 0; here->count = 0;
#define DATA_VL_UB(name, count) DATA_VL_CH(name, count)
#define DATA_VL_SB(name, count) DATA_VL_CH(name, count)
#define DATA_VL_UW(name, count) DATA_VL_CH(name, count)
#define DATA_VL_SW(name, count) DATA_VL_CH(name, count)
#define DATA_VL_UL(name, count) DATA_VL_CH(name, count)
#define DATA_VL_SL(name, count) DATA_VL_CH(name, count)
#define DATA_VL_SQ(name, count) DATA_VL_CH(name, count)

/* n is an expression or variable. */
#define DATA_VR_CH(name,n) DATA_VL_CH(name, _n_ ## name)
#define DATA_VR_UB(name,n) DATA_VL_CH(name, _n_ ## name)
#define DATA_VR_SB(name,n) DATA_VL_CH(name, _n_ ## name)
#define DATA_VR_UW(name,n) DATA_VL_CH(name, _n_ ## name)
#define DATA_VR_SW(name,n) DATA_VL_CH(name, _n_ ## name)
#define DATA_VR_UL(name,n) DATA_VL_CH(name, _n_ ## name)
#define DATA_VR_SL(name,n) DATA_VL_CH(name, _n_ ## name)
#define DATA_VR_SQ(name,n) DATA_VL_CH(name, _n_ ## name)

#define ALT_UB(name)
#define ALT_SB(name)
#define ALT_UW(name)
#define ALT_SW(name)
#define ALT_UL(name)
#define ALT_SL(name)
#define ALT_SQ(name)
#define ZERO(name)

#define DATA_STR(field, type) free_ ## type(&here->field);
#define ARRAY_VC(field, n, type) ARRAY_TC(field, type)
#define ARRAY_TC(field, type)\
  free_ ## type(here->field);\
  free(here->field);\
  here->field = 0;

#if 0
  #define IF(condition) if (condition) {
  #define ELSE } else {
  #define ELSEIF(condition) } else if (condition) {
  #define ENDIF }
#else
  #define IF(condition)
  #define ELSE
  #define ELSEIF(condition)
  #define ENDIF
#endif
#define LAST_ONE
#define NOT_LAST_ONE
