/*
Conversion of data definition to C structures
Copyright (C) 2004      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
#ifdef DATA_UB
  #include "manip_undef.h"
#endif
#define STRUCTURE(type) struct type {struct type *_next;
#define END_STRUCTURE(type) };
#define ALIGN(n)

#define DATA_CH(name) char name;
#define DATA_UB(name) unsigned char name;
#define DATA_SB(name) signed char name;
#define DATA_UW(name) unsigned short int name;
#define DATA_SW(name) signed short int name;
#define DATA_UL(name) unsigned int name;
#define DATA_SL(name) signed int name;
#define DATA_SQ(name) unsigned long long int name;

/* n is a compile-time constant. */
#define DATA_N_CH(name,n) char name[n];
#define DATA_N_UB(name,n) unsigned char name[n];
#define DATA_N_SB(name,n) signed char name[n];
#define DATA_N_UW(name,n) unsigned short int name[n];
#define DATA_N_SW(name,n) signed short int name[n];
#define DATA_N_UL(name,n) unsigned int name[n];
#define DATA_N_SL(name,n) signed int name[n];
#define DATA_N_SQ(name,n) unsigned long long int name[n];

/* count is another field in the same record.
   Note that these structures are not implicitly dynamic. */
#define DATA_VL_CH(name, count) char *name;
#define DATA_VL_UB(name, count) unsigned char *name;
#define DATA_VL_SB(name, count) signed char *name;
#define DATA_VL_UW(name, count) unsigned short int *name;
#define DATA_VL_SW(name, count) signed short int *name;
#define DATA_VL_UL(name, count) unsigned int *name;
#define DATA_VL_SL(name, count) signed int *name;
#define DATA_VL_SQ(name, count) unsigned long long int *name;

/* n is an expression or variable. */
#define DATA_VR_CH(name,n) int _n_ ## name; char *name;
#define DATA_VR_UB(name,n) int _n_ ## name; unsigned char *name;
#define DATA_VR_SB(name,n) int _n_ ## name; signed char *name;
#define DATA_VR_UW(name,n) int _n_ ## name; unsigned short int *name;
#define DATA_VR_SW(name,n) int _n_ ## name; signed short int *name;
#define DATA_VR_UL(name,n) int _n_ ## name; unsigned int *name;
#define DATA_VR_SL(name,n) int _n_ ## name; signed int *name;
#define DATA_VR_SQ(name,n) int _n_ ## name; unsigned long long int *name;

#define ALT_UB(name)
#define ALT_SB(name)
#define ALT_UW(name)
#define ALT_SW(name)
#define ALT_UL(name)
#define ALT_SL(name)
#define ALT_SQ(name)
#define ZERO(name)

#define DATA_STR(field, type) struct type field;
#define ARRAY_VC(field, n, type) struct type *field;
#define ARRAY_TC(field, type) struct type *field;

#define IF(condition)
#define ELSE
#define ELSEIF(condition)
#define ENDIF
#define LAST_ONE
#define NOT_LAST_ONE
