/* Functions for font I/O */
/*
Copyright (C) 2007-2017      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include "manip_structure.h"
#include "oft.h"

int max_UW(unsigned short int *arr, int n) {
  int the_max, i;

  the_max = arr[0];
  for (i=1; i<n; i++) {
    if (arr[i] > the_max) the_max = arr[i];
  }
  return the_max;
}

int advance_coords(int force_advance) {
  while (glyph.n_to_go > 0) {
#define need_next\
    if (!glyph.flag_ptr->_next) {\
      fprintf(stderr, "advance_coords: Mismatch between "\
	      "glyph flags and coordinates.\n");\
      exit(1);\
    }
    if (force_advance) {
      need_next;
      glyph.flag_ptr = glyph.flag_ptr->_next;
    }
    force_advance = 1;
    glyph.flag_is_count = 0;
    glyph.flags = glyph.flag_ptr->val;
    glyph.repeat_count = 1;
    if ((glyph.flags & glyph.short_xy) || !(glyph.flags & glyph.same)) {
      return glyph.n_to_go;
    }
    if (glyph.flags & 8) {
      need_next;
      glyph.flag_ptr = glyph.flag_ptr->_next;
      glyph.repeat_count = 1 + glyph.flag_ptr->val;
    } else {
      glyph.repeat_count = 1;
    }
    glyph.n_to_go -= glyph.repeat_count;
  }
  return glyph.n_to_go > 0;
}

/* Array access function */
void* element(void *base, int index) {
  void *loc;
  for (loc = base; index; index--) loc = *(void**) loc;
  return loc;
}

