/*
Interfaces for routines to write glyph shapes in PostScript file
Copyright (C) 2007-2020      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
#include <stdio.h>
FILE *StartPSFile(const char *name);
void EndPSFile(FILE *fp);
void PSText(FILE *fp, float x, float y, char *str, int cpr);
void NewPSGraph(FILE *fp, float scale, float x0, float y0);
void EndPSGraph(FILE *fp);
void EndPSPage(FILE *fp);
void DrawPSSeg(FILE *fp, float x1, float y1, float x2, float y2,
	     const char *options);
void DrawPSQuad(FILE *fp, float x1, float y1, float x2, float y2,
		float x3, float y3, const char *options);
/* Options: A = Arrow, B = Bold, P = dotted, D = dashed */
void StartPSContour(FILE *fp);
void EndPSContour(FILE *fp, const char *options);
void PSContourPoint(FILE *fp, int x, int y, int ison);
