/*
Interface for tokeniser for OpenType compiler
Copyright (C) 2005-2017      Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
#ifndef TOKENISER_H
#define TOKENISER_H
#include <stdio.h>
struct token {
  double rval;
  char*  sval;
  int    ival; /* Also for punctuation */
  int    lino;
  enum token_type {UNDEFINED = 0,
		   A_STRING, AN_IDENT, AN_INT, A_REAL, PUNCTUATION,
		   END_OF_FILE} form;
};
extern struct token previous, current;

void open_source(const char *filename);
void advance_token();
void backstep_token();
void show_source();
void got_what(FILE *fp, struct token current);
#endif
