/*
Interface definitions for routines for storing and accessing Unicode properties.
Utility to examine and decompile OpenType fonts.
Copyright (C) 2005 Richard Wordingham

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/
#ifndef UNIDATA__H
#define UNIDATA__H 1
/* Set up some database access */
/* Organise Unicode space as 17 by 512 by 128. */
typedef void* datatype;
typedef struct plane {
  datatype (*items[512])[128];
  datatype hblock_default[512];
  int hblock_defaults[16]; /* Packed bit array */
} plane;
typedef struct space {
  plane *plane_ptr[17];
  datatype plane_default[17];
  datatype space_default;
  char plane_defaults[17];
  char space_defaults;
} space;
enum {NOT_FOUND = 0, SPACE_DEFAULT, PLANE_DEFAULT, BLOCK_DEFAULT, FOUND};

int get_property(space db, int onch, datatype *value);
void set_property(space *db, int onch, datatype value, datatype def_value);
void set_property_default(space *db, datatype value);
#endif
